//===================================//
//Ƶ
//ܽܣ
//мĴдʾ
//===================================//
#include "XC8P8508.h"
#define EI()  __asm__(" ei ")
#define DI()  __asm__(" di ")
#define NOP() __asm__(" nop ")
#define CONTW(VAL)			__asm__("mov a,@"#VAL"\n ctw")			//CTW = VALCONTĴֵ
#define IOCP_W(REG,VAL)		__asm__("mov a,@"#VAL"\n iw "#REG)		//REG = VALIOCҳĴֵ
#define IOCP_R(RAM,REG)		__asm__("ir "#REG"\n mov "#RAM",a")		//RAM = REGIOCҳĴֵ
#define PUSH(A_REG,R3_REG)	__asm__("mov "#A_REG",a\n swap "#A_REG"\n swapa STATUS\n mov "#R3_REG",a")	//жջ	
#define POP(A_REG,R3_REG)	__asm__("swapa "#R3_REG"\n mov STATUS,a\n swapa "#A_REG)					//жϳջָ

volatile __at(0x10) unsigned char A_BUFF;		//жACCRAM
volatile __at(0x11) unsigned char R3_BUFF;		//жSTATUSRAM
volatile unsigned char Temp;	
//===================================//
//MAIN
//===================================//
void main()
{
//======================================================//
// Operational Registers Define RPAGE0                  //
//======================================================//
	IAR = 0xAA;					//IARֵ0xAA
	Temp = IAR;					//IARTemp

	TCC = 0xAA;					//TCCֵ0xAA
	Temp = TCC;					//TCCTemp

	PCL = 0xAA;					//PCLֵ0xAA
	Temp = PCL;					//PCLTemp

	STATUS = 0xAA;				//STATUSֵ0xAA
	Temp = STATUS;				//STATUSTemp

	RSR = 0xAA;					//RSRֵ0xAA
	Temp = RSR;					//RSRTemp

	PORT5 = 0xAA;				//PORT5ֵ0xAA
	Temp = PORT5;				//PORT5Temp

	PORT6 = 0xAA;				//PORT6ֵ0xAA
	Temp = PORT6;				//PORT6Temp

	PORT7 = 0xAA;				//PORT7ֵ0xAA
	Temp = PORT7;				//PORT7Temp

	LVDCON = 0xAA;				//LVDCONֵ0xAA
	Temp = LVDCON;				//LVDCONTemp

	P5ICECR = 0xAA;				//P5ICECRֵ0xAA
	Temp = P5ICECR;				//P5ICECRTemp

	P6ICECR = 0xAA;				//P6ICECRֵ0xAA
	Temp = P6ICECR;				//P6ICECRTemp

	CPUCON = 0xAA;				//CPUCONֵ0xAA
	Temp = CPUCON;				//CPUCONTemp

	ISR = 0xAA;					//ISRֵ0xAA
	Temp = ISR;					//ISRTemp


	PWM0CON = 0xAA;				//PWM0CONֵ0xAA
	Temp = PWM0CON;				//PWM0CONTemp

	PWM1CON = 0xAA;				//PWM1CONֵ0xAA
	Temp = PWM1CON;				//PWM1CONTemp

	PWM2CON = 0xAA;				//PWM2CONֵ0xAA
	Temp = PWM2CON;				//PWM2CONTemp

	PWM3CON = 0xAA;				//PWM3CONֵ0xAA
	Temp = PWM3CON;				//PWM3CONTemp

	PWM4CON = 0xAA;				//PWM4CONֵ0xAA
	Temp = PWM4CON;				//PWM4CONTemp

	P5HDCR = 0xAA;				//P5HDCRֵ0xAA
	Temp = P5HDCR;				//P5HDCRTemp

	P5HSCR = 0xAA;				//P5HSCRֵ0xAA
	Temp = P5HSCR;				//P5HSCRTemp

	P6HDCR = 0xAA;				//P6HDCRֵ0xAA
	Temp = P6HDCR;				//P6HDCRTemp

	P6HSCR = 0xAA;				//P6HSCRֵ0xAA
	Temp = P6HSCR;				//P6HSCRTemp

	P5WDCR = 0xAA;				//P5WDCRֵ0xAA
	Temp = P5WDCR;				//P5WDCRTemp

	P5WSCR = 0xAA;				//P5WSCRֵ0xAA
	Temp = P5WSCR;				//P5WSCRTemp

	DEADCON = 0xAA;				//DEADCONֵ0xAA
	Temp = DEADCON;				//DEADCONTemp

	DEADTR = 0xAA;				//DEADTRֵ0xAA
	Temp = DEADTR;				//DEADTRTemp
//======================================================//
// Operational Registers Define IOPAGE0                 //
//======================================================//			
	CONTW(0x08);				//CONTֵ0x08

	IOCP_W(P5CR,0xAA);			//P5CRֵ0xAA
	IOCP_R(_Temp,P5CR);			//P5CRTemp
	
	IOCP_W(P6CR,0xAA);			//P6CRֵ0xAA
	IOCP_R(_Temp,P6CR);			//P6CRTemp

	IOCP_W(P7CR,0xAA);			//P7CRֵ0xAA
	IOCP_R(_Temp,P7CR);			//P7CRTemp
	
	IOCP_W(PHDCR0,0xAA);		//PHDCR0ֵ0xAA
	IOCP_R(_Temp,PHDCR0);		//PHDCR0Temp

	IOCP_W(PHDCR1,0xAA);		//PHDCR1ֵ0xAA
	IOCP_R(_Temp,PHDCR1);		//PHDCR1Temp

	IOCP_W(PHDCR2,0xAA);		//PHDCR2ֵ0xAA
	IOCP_R(_Temp,PHDCR2);		//PHDCR2Temp

	IOCP_W(PDCR,0xAA);			//PDCRֵ0xAA
	IOCP_R(_Temp,PDCR);			//PDCRTemp

	IOCP_W(P6ODCR,0xAA);		//P6ODCRֵ0xAA
	IOCP_R(_Temp,P6ODCR);		//P6ODCRTemp

	IOCP_W(P6PHCR,0xAA);		//P6PHCRֵ0xAA
	IOCP_R(_Temp,P6PHCR);		//P6PHCRTemp

	IOCP_W(WDTCR,0xAA);			//WDTCRֵ0xAA
	IOCP_R(_Temp,WDTCR);		//WDTCRTemp

	IOCP_W(IMR,0xAA);			//IMRֵ0xAA
	IOCP_R(_Temp,IMR);			//IMRTemp


	IOCP_W(PRDCH0,0xAA);		//PRDCH0ֵ0xAA
	IOCP_R(_Temp,PRDCH0);		//PRDCH0Temp

	IOCP_W(PRDL0,0xAA);			//PRDL0ֵ0xAA
	IOCP_R(_Temp,PRDL0);		//PRDL0Temp

	IOCP_W(PDCL0,0xAA);			//PDCL0ֵ0xAA
	IOCP_R(_Temp,PDCL0);		//PDCL0Temp

	IOCP_W(PRDCH1,0xAA);		//PRDCH1ֵ0xAA
	IOCP_R(_Temp,PRDCH1);		//PRDCH1Temp

	IOCP_W(PRDL1,0xAA);			//PRDL1ֵ0xAA
	IOCP_R(_Temp,PRDL1);		//PRDL1Temp

	IOCP_W(PDCL1,0xAA);			//PDCL1ֵ0xAA
	IOCP_R(_Temp,PDCL1);		//PDCL1Temp

	IOCP_W(PRDCH2,0xAA);		//PRDCH2ֵ0xAA
	IOCP_R(_Temp,PRDCH2);		//PRDCH2Temp

	IOCP_W(PRDL2,0xAA);			//PRDL2ֵ0xAA
	IOCP_R(_Temp,PRDL2);		//PRDL2Temp

	IOCP_W(PDCL2,0xAA);			//PDCL2ֵ0xAA
	IOCP_R(_Temp,PDCL2);		//PDCL2Temp

	IOCP_W(PRDCH3,0xAA);		//PRDCH3ֵ0xAA
	IOCP_R(_Temp,PRDCH3);		//PRDCH3Temp

	IOCP_W(PRDL3,0xAA);			//PRDL3ֵ0xAA
	IOCP_R(_Temp,PRDL3);		//PRDL3Temp

	IOCP_W(PDCL3,0xAA);			//PDCL3ֵ0xAA
	IOCP_R(_Temp,PDCL3);		//PDCL3Temp

	IOCP_W(PRDCH4,0xAA);		//PRDCH4ֵ0xAA
	IOCP_R(_Temp,PRDCH4);		//PRDCH4Temp

	IOCP_W(PRDL4,0xAA);			//PRDL4ֵ0xAA
	IOCP_R(_Temp,PRDL4);		//PRDL4Temp

	IOCP_W(PDCL4,0xAA);			//PDCL4ֵ0xAA
	IOCP_R(_Temp,PDCL4);		//PDCL4Temp

	IOCP_W(PWMSCR,0xAA);		//PWMSCRֵ0xAA
	IOCP_R(_Temp,PWMSCR);		//PWMSCRTemp
}

//===================================//
//жϷ
//===================================//
void int_isr(void) __interrupt 
{    	
	__asm__("org 0x08");
	PUSH(_A_BUFF,_R3_BUFF);			//жջ
	//===============жϳ===============//
	
	//===============жϳ===============//
	POP(_A_BUFF,_R3_BUFF);			//жϳջָ
}
