;--------------------------------------------------------
; File Created by SLCC : free open source ANSI-C Compiler
; Version 3.6.0 #Dec 13 2021 (MSVC)
;--------------------------------------------------------
; SL port for the RISC core
;--------------------------------------------------------
;	.file	"E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C"
	list	p=XC8P8508
	radix dec
	include "XC8P8508.inc"
;--------------------------------------------------------
; external declarations
;--------------------------------------------------------
	extern	_IARbits
	extern	_TCCbits
	extern	_PCLbits
	extern	_STATUSbits
	extern	_RSRbits
	extern	_PORT5bits
	extern	_PORT6bits
	extern	_PORT7bits
	extern	_LVDCONbits
	extern	_P5ICECRbits
	extern	_P6ICECRbits
	extern	_CPUCONbits
	extern	_ISRbits
	extern	_PWM0CONbits
	extern	_PWM1CONbits
	extern	_PWM2CONbits
	extern	_PWM3CONbits
	extern	_PWM4CONbits
	extern	_P5HDCRbits
	extern	_P5HSCRbits
	extern	_P6HDCRbits
	extern	_P6HSCRbits
	extern	_P5WDCRbits
	extern	_P5WSCRbits
	extern	_DEADCONbits
	extern	_DEADTRbits
	extern	_IAR
	extern	_TCC
	extern	_PCL
	extern	_STATUS
	extern	_RSR
	extern	_PORT5
	extern	_PORT6
	extern	_PORT7
	extern	_LVDCON
	extern	_P5ICECR
	extern	_P6ICECR
	extern	_CPUCON
	extern	_ISR
	extern	_PWM0CON
	extern	_PWM1CON
	extern	_PWM2CON
	extern	_PWM3CON
	extern	_PWM4CON
	extern	_P5HDCR
	extern	_P5HSCR
	extern	_P6HDCR
	extern	_P6HSCR
	extern	_P5WDCR
	extern	_P5WSCR
	extern	_DEADCON
	extern	_DEADTR
;--------------------------------------------------------
; global declarations
;--------------------------------------------------------
	global	_file_clrRam
	global	_file_init
	global	_file_project_init
	global	_int_isr
	global	_main
	global	_A_BUFF
	global	_R3_BUFF
	global	_reg_keyCont
	global	_reg_sleep_cnt
	global	_flag_mode
	global	_flag_key

	global STK11
	global STK10
	global STK09
	global STK08
	global STK07
	global STK06
	global STK05
	global STK04
	global STK03
	global STK02
	global STK01
	global STK00

sharebank udata_ovr 0x0020
STK11	res 1
STK10	res 1
STK09	res 1
STK08	res 1
STK07	res 1
STK06	res 1
STK05	res 1
STK04	res 1
STK03	res 1
STK02	res 1
STK01	res 1
STK00	res 1

;--------------------------------------------------------
; global definitions
;--------------------------------------------------------
UD_XC8P8508_INTERRUPT_0	udata
_reg_keyCont	res	1

UD_XC8P8508_INTERRUPT_1	udata
_reg_sleep_cnt	res	1

UD_XC8P8508_INTERRUPT_2	udata
_flag_mode	res	1

UD_XC8P8508_INTERRUPT_3	udata
_flag_key	res	1

;--------------------------------------------------------
; absolute symbol definitions
;--------------------------------------------------------
UD_abs_XC8P8508_INTERRUPT_10	udata_ovr	0x0010
_A_BUFF
	res	1
UD_abs_XC8P8508_INTERRUPT_11	udata_ovr	0x0011
_R3_BUFF
	res	1
;--------------------------------------------------------
; compiler-defined variables
;--------------------------------------------------------
UDL_XC8P8508_INTERRUPT_0	udata
r0x1000	res	1
r0x1001	res	1
;--------------------------------------------------------
; initialized data
;--------------------------------------------------------

;@Allocation info for local variables in function 'file_clrRam'
;@file_clrRam file_clrRam               Allocated to registers ;size:2
;@file_clrRam IARbits                   Allocated to registers ;size:1
;@file_clrRam TCCbits                   Allocated to registers ;size:1
;@file_clrRam PCLbits                   Allocated to registers ;size:1
;@file_clrRam STATUSbits                Allocated to registers ;size:1
;@file_clrRam RSRbits                   Allocated to registers ;size:1
;@file_clrRam PORT5bits                 Allocated to registers ;size:1
;@file_clrRam PORT6bits                 Allocated to registers ;size:1
;@file_clrRam PORT7bits                 Allocated to registers ;size:1
;@file_clrRam LVDCONbits                Allocated to registers ;size:1
;@file_clrRam P5ICECRbits               Allocated to registers ;size:1
;@file_clrRam P6ICECRbits               Allocated to registers ;size:1
;@file_clrRam CPUCONbits                Allocated to registers ;size:1
;@file_clrRam ISRbits                   Allocated to registers ;size:1
;@file_clrRam PWM0CONbits               Allocated to registers ;size:1
;@file_clrRam PWM1CONbits               Allocated to registers ;size:1
;@file_clrRam PWM2CONbits               Allocated to registers ;size:1
;@file_clrRam PWM3CONbits               Allocated to registers ;size:1
;@file_clrRam PWM4CONbits               Allocated to registers ;size:1
;@file_clrRam P5HDCRbits                Allocated to registers ;size:1
;@file_clrRam P5HSCRbits                Allocated to registers ;size:1
;@file_clrRam P6HDCRbits                Allocated to registers ;size:1
;@file_clrRam P6HSCRbits                Allocated to registers ;size:1
;@file_clrRam P5WDCRbits                Allocated to registers ;size:1
;@file_clrRam P5WSCRbits                Allocated to registers ;size:1
;@file_clrRam DEADCONbits               Allocated to registers ;size:1
;@file_clrRam DEADTRbits                Allocated to registers ;size:1
;@file_clrRam A_BUFF                    Allocated to registers ;size:1
;@file_clrRam R3_BUFF                   Allocated to registers ;size:1
;@file_clrRam reg_keyCont               Allocated to registers ;size:1
;@file_clrRam reg_sleep_cnt             Allocated to registers ;size:1
;@file_clrRam flag_mode                 Allocated to registers ;size:1
;@file_clrRam flag_key                  Allocated to registers ;size:1
;@file_clrRam IAR                       Allocated to registers ;size:1
;@file_clrRam TCC                       Allocated to registers ;size:1
;@file_clrRam PCL                       Allocated to registers ;size:1
;@file_clrRam STATUS                    Allocated to registers ;size:1
;@file_clrRam RSR                       Allocated to registers ;size:1
;@file_clrRam PORT5                     Allocated to registers ;size:1
;@file_clrRam PORT6                     Allocated to registers ;size:1
;@file_clrRam PORT7                     Allocated to registers ;size:1
;@file_clrRam LVDCON                    Allocated to registers ;size:1
;@file_clrRam P5ICECR                   Allocated to registers ;size:1
;@file_clrRam P6ICECR                   Allocated to registers ;size:1
;@file_clrRam CPUCON                    Allocated to registers ;size:1
;@file_clrRam ISR                       Allocated to registers ;size:1
;@file_clrRam PWM0CON                   Allocated to registers ;size:1
;@file_clrRam PWM1CON                   Allocated to registers ;size:1
;@file_clrRam PWM2CON                   Allocated to registers ;size:1
;@file_clrRam PWM3CON                   Allocated to registers ;size:1
;@file_clrRam PWM4CON                   Allocated to registers ;size:1
;@file_clrRam P5HDCR                    Allocated to registers ;size:1
;@file_clrRam P5HSCR                    Allocated to registers ;size:1
;@file_clrRam P6HDCR                    Allocated to registers ;size:1
;@file_clrRam P6HSCR                    Allocated to registers ;size:1
;@file_clrRam P5WDCR                    Allocated to registers ;size:1
;@file_clrRam P5WSCR                    Allocated to registers ;size:1
;@file_clrRam DEADCON                   Allocated to registers ;size:1
;@file_clrRam DEADTR                    Allocated to registers ;size:1
;@end Allocation info for local variables in function 'file_clrRam';

;--------------------------------------------------------
; overlayable items in internal ram 
;--------------------------------------------------------
;	udata_ovr
;--------------------------------------------------------
; reset vector 
;--------------------------------------------------------
STARTUP	code 0x0000
	jmp	_main
;--------------------------------------------------------
; interrupt and initialization code
;--------------------------------------------------------
c_interrupt	code	0x0003
__sdcc_interrupt:
;***
;  pBlock Stats: dbName = I
;***
;2 compiler assigned registers:
;   r0x1000
;   r0x1001
;; Starting pCode block
_int_isr:	;Function start
; 0 exit points
;	.line	112; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	__asm__("org 0x08");			//жڵַ			
	org	0x08
;	.line	113; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	PUSH(_A_BUFF,_R3_BUFF);			//жջ
	mov	_A_BUFF,a
	swap	_A_BUFF
	swapa	STATUS
	mov	_R3_BUFF,a
;	.line	115; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	if(TCIF == 1)					//жTCIFǷΪ1
	CLR	r0x1000
	JBTC	_ISRbits,0
	INC	r0x1000
;;114	MOV	A,r0x1000
;;113	MOV	A,r0x1001
	MOV	A,r0x1000
	MOV	r0x1001,A
	XOR	A,@0x01
	JBTS	STATUS,2
	JMP	_00121_DS_
;	.line	117; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	TCC	  += 0x06;				//1/2 * 8 * (256-6) = 1000us	ʽ1/IRCƵ * ԤƵ * 256-ֵ
	MOV	A,@0x06
	ADD	_TCC,A
;	.line	118; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	ISR    = 0xfe;				//TC0жϱ־λ
	MOV	A,@0xfe
	MOV	_ISR,A
;	.line	119; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	PORT6^= 0X01;		//P61ڷת
	MOV	A,@0x01
	XOR	_PORT6,A
_00121_DS_:
;	.line	122; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	if(PWM0IF == 1)					//pwm0ж100us
	CLR	r0x1000
	JBTC	_ISRbits,5
	INC	r0x1000
;;112	MOV	A,r0x1000
;;111	MOV	A,r0x1001
	MOV	A,r0x1000
	MOV	r0x1001,A
	XOR	A,@0x01
	JBTS	STATUS,2
	JMP	_00123_DS_
;	.line	124; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	ISR    = 0xdf;				//ISRbit5:PWM0IF
	MOV	A,@0xdf
	MOV	_ISR,A
;	.line	125; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	PORT5^= 0X10;			    //P54ڷת
	MOV	A,@0x10
	XOR	_PORT5,A
_00123_DS_:
;	.line	128; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	if(PWM1IF == 1)					//pwm1ж200us
	CLR	r0x1000
	JBTC	_ISRbits,6
	INC	r0x1000
;;110	MOV	A,r0x1000
;;109	MOV	A,r0x1001
	MOV	A,r0x1000
	MOV	r0x1001,A
	XOR	A,@0x01
	JBTS	STATUS,2
	JMP	_00125_DS_
;	.line	130; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	ISR    = 0xbf;				//ISRbit6:PWM1IF
	MOV	A,@0xbf
	MOV	_ISR,A
;	.line	131; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	PORT6^= 0X10;			    //P64ڷת
	MOV	A,@0x10
	XOR	_PORT6,A
_00125_DS_:
;	.line	134; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	if(PWM2IF == 1)					//pwm2ж300us
	CLR	r0x1000
	JBTC	_ISRbits,7
	INC	r0x1000
;;108	MOV	A,r0x1000
;;107	MOV	A,r0x1001
	MOV	A,r0x1000
	MOV	r0x1001,A
	XOR	A,@0x01
	JBTS	STATUS,2
	JMP	_00127_DS_
;	.line	136; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	ISR    = 0x7f;				//ISRbit7:PWM2IF
	MOV	A,@0x7f
	MOV	_ISR,A
;	.line	137; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	PORT6^= 0X20;			    //P65ڷת
	MOV	A,@0x20
	XOR	_PORT6,A
_00127_DS_:
;	.line	140; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	if(LVDIF == 1)					//ISRbit4:LVDIF 
	CLR	r0x1000
	JBTC	_ISRbits,4
	INC	r0x1000
;;106	MOV	A,r0x1000
;;105	MOV	A,r0x1001
	MOV	A,r0x1000
	MOV	r0x1001,A
	XOR	A,@0x01
	JBTS	STATUS,2
	JMP	_00129_DS_
;	.line	142; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	ISR    = 0xEF;				//ISRbit4:LVDIF 
	MOV	A,@0xef
	MOV	_ISR,A
;	.line	143; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	PORT6^= 0X10;			    //P64ڷת
	MOV	A,@0x10
	XOR	_PORT6,A
_00129_DS_:
;	.line	146; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	if(EXIF == 1)					//ISRbit2:EXIF 
	CLR	r0x1000
	JBTC	_ISRbits,2
	INC	r0x1000
;;104	MOV	A,r0x1000
;;103	MOV	A,r0x1001
	MOV	A,r0x1000
	MOV	r0x1001,A
	XOR	A,@0x01
	JBTS	STATUS,2
	JMP	_00131_DS_
;	.line	148; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	ISR    = 0xFB;				//ISRbit2:EXIF 
	MOV	A,@0xfb
	MOV	_ISR,A
;	.line	149; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	PORT6^= 0X10;			    //P64ڷת
	MOV	A,@0x10
	XOR	_PORT6,A
_00131_DS_:
;	.line	152; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	if(P5ICIF == 1)					// 
	CLR	r0x1000
	JBTC	_ISRbits,3
	INC	r0x1000
;;102	MOV	A,r0x1000
;;101	MOV	A,r0x1001
	MOV	A,r0x1000
	MOV	r0x1001,A
	XOR	A,@0x01
	JBTS	STATUS,2
	JMP	_00133_DS_
;	.line	154; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	ISR    = 0xF7;				//ISRbit3:P5ICIF 
	MOV	A,@0xf7
	MOV	_ISR,A
;	.line	155; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	PORT6^= 0X10;			    //P64ڷת
	MOV	A,@0x10
	XOR	_PORT6,A
_00133_DS_:
;	.line	158; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	if(P6ICIF == 1)					// 
	CLR	r0x1000
	JBTC	_ISRbits,1
	INC	r0x1000
;;100	MOV	A,r0x1000
;;99	MOV	A,r0x1001
	MOV	A,r0x1000
	MOV	r0x1001,A
	XOR	A,@0x01
	JBTS	STATUS,2
	JMP	_00135_DS_
;	.line	160; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	ISR    = 0xFD;				//ISRbit1:P6ICIF 
	MOV	A,@0xfd
	MOV	_ISR,A
;	.line	161; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	PORT6^= 0X10;			    //P64ڷת
	MOV	A,@0x10
	XOR	_PORT6,A
_00135_DS_:
;	.line	164; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	POP(_A_BUFF,_R3_BUFF);			//жϳջָ
	swapa	_R3_BUFF
	mov	STATUS,a
	swapa	_A_BUFF
;	.line	165; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	}
END_OF_INTERRUPT:
	RETI	

;--------------------------------------------------------
; code
;--------------------------------------------------------
code_XC8P8508_INTERRUPT	code
;***
;  pBlock Stats: dbName = M
;***
;has an exit
;functions called:
;   _file_clrRam
;   _file_init
;   _file_project_init
;   _file_clrRam
;   _file_init
;   _file_project_init
;; Starting pCode block
S_XC8P8508_INTERRUPT__main	code
_main:	;Function start
; 2 exit points
;	.line	173; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	file_clrRam();					//RAM
	CALL	_file_clrRam
;	.line	174; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	file_init();					//ioĴʼ
	CALL	_file_init
;	.line	175; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	file_project_init();			//蹦
	CALL	_file_project_init
;	.line	176; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	EI();							//ж
	ei	
_00141_DS_:
;	.line	180; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	NOP();
	nop	
;	.line	181; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	NOP();
	nop	
;	.line	182; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	NOP();
	nop	
	JMP	_00141_DS_
;	.line	184; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	}
	RET	
; exit point of _main

;***
;  pBlock Stats: dbName = C
;***
;has an exit
;; Starting pCode block
S_XC8P8508_INTERRUPT__file_project_init	code
_file_project_init:	;Function start
; 2 exit points
;	.line	103; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	IOCP_W(IMR,0x11);		//;LVDж	
	mov	a,@0x11
	iw	IMR
;	.line	104; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	LVDCON=0X8D;			// ;ʹLVD ѡVDD	õѹ3.3V
	MOV	A,@0x8d
	MOV	_LVDCON,A
;	.line	105; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	ISR = 0x0;
	CLR	_ISR
;	.line	106; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	}
	RET	
; exit point of _file_project_init

;***
;  pBlock Stats: dbName = C
;***
;has an exit
;; Starting pCode block
S_XC8P8508_INTERRUPT__file_init	code
_file_init:	;Function start
; 2 exit points
;	.line	47; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	CONTW(0x02);			//TCC 8Ƶ
	mov	a,@0x02
	ctw
;	.line	48; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	TCC = 6;			//1/2 * 8 * (256-6) = 1000us	ʽ1/IRCƵ * ԤƵ * 256-ֵ
	MOV	A,@0x06
	MOV	_TCC,A
;	.line	49; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	PORT5 = 0;				//P5
	CLR	_PORT5
;	.line	50; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	PORT6 = 0;				//P6
	CLR	_PORT6
;	.line	51; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	PORT7 = 0;				//P7
	CLR	_PORT7
;	.line	52; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	IOCP_W(P5CR,0x08);		//P5Ϊ
	mov	a,@0x08
	iw	P5CR
;	.line	53; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	IOCP_W(P6CR,0x08);		//P6Ϊ
	mov	a,@0x08
	iw	P6CR
;	.line	54; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	IOCP_W(P7CR,0x00);		//P7Ϊ
	mov	a,@0x00
	iw	P7CR
;	.line	56; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	IOCP_W(PHDCR0,0x00);	//Bit5-bit4:P71-P70 λ Bit1-bit0:P71-P70λ	
	mov	a,@0x00
	iw	PHDCR0
;	.line	57; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	IOCP_W(PHDCR1,0xf7);	//˿ƼĴ1:0ʹ,1ֹ bit7-bit4:P67-P64;bit3-bit0:P53-P50
	mov	a,@0xf7
	iw	PHDCR1
;	.line	58; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	IOCP_W(PHDCR2,0xff);	//˿ƼĴ2:0ʹ,1ֹ bit6-bit4:P56-P54;bit3-bit0:P57-P54
	mov	a,@0xff
	iw	PHDCR2
;	.line	59; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	IOCP_W(PDCR,0xff);		//˿ƼĴ   :0ʹ,1ֹ bit7-bit4:P63-P60,bit3-bit0:P53-P50
	mov	a,@0xff
	iw	PDCR
;	.line	60; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	IOCP_W(P6ODCR,0x00);
	mov	a,@0x00
	iw	P6ODCR
;	.line	61; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	IOCP_W(P6PHCR,0xf7);	//P6˿ƼĴ :0ʹ,1ֹ bit7-bit0:P67-P60
	mov	a,@0xf7
	iw	P6PHCR
;	.line	62; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	IOCP_W(WDTCR,0x00);		//WDT ʹܿƼĴ
	mov	a,@0x00
	iw	WDTCR
;	.line	63; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	IOCP_W(IMR,0x01);		//жʹܿƼĴ 
	mov	a,@0x01
	iw	IMR
;	.line	64; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	ISR = 0x0;				//TC0жϱ־λ 
	CLR	_ISR
;	.line	65; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	}
	RET	
; exit point of _file_init

;***
;  pBlock Stats: dbName = C
;***
;has an exit
;; Starting pCode block
S_XC8P8508_INTERRUPT__file_clrRam	code
_file_clrRam:	;Function start
; 2 exit points
;	.line	37; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	for(RSR=0x90;RSR<0xFF;RSR++)	// BANK0 RAM  IAR-R0,RSR-R4
	MOV	A,@0x90
	MOV	_RSR,A
_00107_DS_:
	MOV	A,@0xff
	SUB	A,_RSR
	JBTC	STATUS,0
	JMP	_00105_DS_
;	.line	39; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	{IAR = 0;}
	CLR	_IAR
;	.line	37; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	for(RSR=0x90;RSR<0xFF;RSR++)	// BANK0 RAM  IAR-R0,RSR-R4
	INC	_RSR
	JMP	_00107_DS_
_00105_DS_:
;	.line	40; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	IAR = 0;
	CLR	_IAR
;	.line	41; E:\00ܵƬDEMO\XC8P8508_DEMO\XC8P8508_DEMO_C\6_XC8P8508_жģ\XC8P8508-INTERRUPT.C	}
	RET	
; exit point of _file_clrRam


;	code size estimation:
;	  126+    0 =   126 instructions (  252 byte)

	end
